# AI_AUTO_PLAY_MOD
#
# by jdog5000
# version 1.4

from CvPythonExtensions import *
import CvTopCivs
import CvUtil
import PyHelpers		
import Popup as PyPopup

# globals
gc = CyGlobalContext()
localText = CyTranslator()
PyPlayer = PyHelpers.PyPlayer
PyInfo = PyHelpers.PyInfo
game = CyGame()

class AIAutoPlay :

    def __init__(self, customEM, config = None ) :

        CvUtil.pyPrint("Initializing AIAutoPlay Mod")

        self.LOG_DEBUG = False
        self.SHOW_NEW_LEADER_POPUP = True
        self.blockPopups = True
        self.refortify = True
        self.toAIChooserPopup = 7000
        self.abdicatePopup = 7001
        self.pickHumanPopup = 7014
        
        if( not config == None ) :
            self.LOG_DEBUG = config.getboolean("AIAutoPlay", "DebugMode", self.LOG_DEBUG)
            self.SHOW_NEW_LEADER_POPUP = config.getboolean("AIAutoPlay", "ShowNewLeaderPopup", self.SHOW_NEW_LEADER_POPUP)
            self.blockPopups = config.getboolean("AIAutoPlay", "BlockPopups", self.blockPopups)
            self.refortify = config.getboolean("AIAutoPlay", "Refortify", self.refortify)
            self.toAIChooserPopup = config.getint("Popup Handler", "AI Chooser", self.toAIChooserPopup)
            self.abdicatePopup = config.getint("Popup Handler", "Abdicate", self.abdicatePopup)
            self.pickHumanPopup = config.getint("Popup Handler", "Pick Human", self.pickHumanPopup)

        self.EventKeyDown=6
        self.TurnsToAuto = 10
        

        self.playerID = 0

        self.AutoCounter = 0

        self.bCanCancelAuto = False

        self.AutoTypes={
            0 : 'No automation',
            1 : 'Fully Automate',
            #2 : 'Automate unit moves only (not fully tested)',
            #3 : 'Debug Mode (will reveal entire world!!!)',
            }

        self.customEM = customEM

        self.customEM.addEventHandler( "kbdEvent", self.onKbdEvent )
        self.customEM.addEventHandler( "EndGameTurn", self.onEndGameTurn )
        self.customEM.addEventHandler( 'BeginPlayerTurn', self.onBeginPlayerTurn )
        self.customEM.addEventHandler( 'EndPlayerTurn', self.onEndPlayerTurn )

        self.customEM.setPopupHandler( self.toAIChooserPopup, ["toAIChooserPopup",self.AIChooserHandler,self.blankHandler] )
        self.customEM.setPopupHandler( self.abdicatePopup, ["abdicatePopup",self.abdicateHandler,self.blankHandler] )
        self.customEM.setPopupHandler( self.pickHumanPopup, ["pickHumanPopup",self.pickHumanHandler,self.blankHandler] )

        
        if( self.blockPopups ) :
            print "Removing some event handlers"
            try :
                self.customEM.removeEventHandler( "cityBuilt", customEM.onCityBuilt )
                self.customEM.addEventHandler( "cityBuilt", self.onCityBuilt )
            except ValueError :
                print "Failed to remove 'onCityBuilt', perhaps not registered"
                self.customEM.setEventHandler( "cityBuilt", self.onCityBuilt )
            
            try :
                self.customEM.removeEventHandler( "BeginGameTurn", customEM.onBeginGameTurn )
                self.customEM.addEventHandler( "BeginGameTurn", self.onBeginGameTurn )
            except ValueError :
                print "Failed to remove 'onBeginGameTurn', perhaps not registered"
                self.customEM.setEventHandler( "BeginGameTurn", self.onBeginGameTurn )
            

    def blankHandler( self, playerID, netUserData, popupReturn ) :
        # Dummy handler to take the second event for popup
        return
    

    def onEndGameTurn( self, argsList ) :
        if( game.getAIAutoPlay() == 1 ) :
            # About to turn off automation
            self.bCanCancelAuto = False

    def pickHumanHandler( self, iPlayerID, netUserData, popupReturn ) :

        CvUtil.pyPrint('Handling pick human popup')

        if( popupReturn.getButtonClicked() == 0 ):  # if you pressed cancel
            return

        toKillPlayer = gc.getActivePlayer()

        newHumanIdx = popupReturn.getSelectedPullDownValue( 1 )
        newPlayer = gc.getPlayer(newHumanIdx)

        game.setActivePlayer( newHumanIdx, False )
        success = game.changePlayer( newHumanIdx, newPlayer.getCivilizationType(), newPlayer.getLeaderType(), -1, True, False )

        if( success ) :
            CvUtil.pyPrint("You now control the %s"%(newPlayer.getCivilizationDescription(0)))
            CyInterface().addImmediateMessage("You now control the %s"%(newPlayer.getCivilizationDescription(0)),"")
            
        if( toKillPlayer.getNumCities() == 0 ) :
            # Kills off the lion in the ice field
            CvUtil.pyPrint("Killing off player %d"%(toKillPlayer.getID()))
            toKillPlayer.killUnits()
            success = game.changePlayer( toKillPlayer.getID(), toKillPlayer.getCivilizationType(), toKillPlayer.getLeaderType(), -1, False, False )
            toKillPlayer.setNewPlayerAlive(False)

    def onBeginPlayerTurn( self, argsList ) :
        iGameTurn, iPlayer = argsList

        if( iPlayer == gc.getBARBARIAN_PLAYER() and game.getAIAutoPlay() == 1 ) :
            # About to turn off automation
            self.bCanCancelAuto = False
            self.checkDeadPlayer()
            

    def onEndPlayerTurn( self, argsList ) :
        iGameTurn, iPlayer = argsList

        # Can't use isHuman as isHuman has been deactivated by automation
        if( self.refortify and iPlayer == game.getActivePlayer() and game.getAIAutoPlay() == 1 ) :
            self.doRefortify( iPlayer )

    def checkDeadPlayer( self ) :
        CvUtil.pyPrint('Setting autoplay to 0')
        game.setAIAutoPlay(0)

        pPlayer = gc.getActivePlayer()

        if( not pPlayer.isAlive() ) :
            popup = PyPopup.PyPopup(self.pickHumanPopup,contextType = EventContextTypes.EVENTCONTEXT_ALL)
            popup.setHeaderString( localText.getText("TXT_KEY_AIAUTOPLAY_PICK_CIV", ()) )
	    popup.setBodyString( localText.getText("TXT_KEY_AIAUTOPLAY_CIV_DIED", ()) )
            popup.addSeparator()
            
            popup.createPythonPullDown( localText.getText("TXT_KEY_AIAUTOPLAY_TAKE_CONTROL_CIV", ()), 1 )
            for i in range(0,gc.getMAX_CIV_PLAYERS()) :
                player = PyPlayer(i)
                if( not player.isNone() and not i == pPlayer.getID() ) :
                    if( player.isAlive() ) :
                        popup.addPullDownString( localText.getText("TXT_KEY_AIAUTOPLAY_OF_THE", ())%(player.getName(),player.getCivilizationName()), i, 1 )

            activePlayerIdx = gc.getActivePlayer().getID()
            popup.popup.setSelectedPulldownID( activePlayerIdx, 1 )
            
            popup.addSeparator()
     
            popup.addButton( localText.getText("TXT_KEY_AIAUTOPLAY_NONE", ()) )
            CvUtil.pyPrint('Launching pick human popup')
            popup.launch()
            
        elif( not pPlayer.isHuman() ) :
            CvUtil.pyPrint('Returning human player to control of %s'%(pPlayer.getCivilizationDescription(0)))
            game.setActivePlayer( pPlayer.getID(), False )
            success = game.changePlayer( pPlayer.getID(), pPlayer.getCivilizationType(), pPlayer.getLeaderType(), -1, True, False )

        CvUtil.pyPrint('Setting autoplay to 1')
        game.setAIAutoPlay(1)
           
    def doRefortify( self, iPlayer ) :
         #pyPlayer = PyPlayer( iPlayer )
        pPlayer = gc.getPlayer(iPlayer)

##        for unit in pyPlayer.getUnitList() :
##            if( unit.fortifyModifier() > 0 ) :
##                pGroup = unit.getGroup()
##                if pGroup.getActivityType() != ActivityTypes.ACTIVITY_SLEEP:
##                    pGroup.setActivityType(ActivityTypes.ACTIVITY_SLEEP)
##                #if( pGroup.getLengthMissionQueue() == 0 ) :
##                #pGroup.pushMission( MissionTypes.MISSION_FORTIFY, 0, 0, 0, False, True, MissionAITypes.MISSIONAI_GUARD_CITY, unit.plot(), unit )
        for groupID in range(0,pPlayer.getNumSelectionGroups()) :
            pGroup = pPlayer.getSelectionGroup(groupID)
            if( pGroup.getNumUnits() > 0 ) :

                headUnit = pGroup.getHeadUnit()
                #CvUtil.pyPrint( "%s fortTurns %d"%(headUnit.getName(),headUnit.getFortifyTurns()) )
                if( headUnit.getFortifyTurns() > 0 ) :
                    if( headUnit.isHurt() ) :
                        #CvUtil.pyPrint( "%s is hurt"%(headUnit.getName()) )
                        #pGroup.setActivityType(ActivityTypes.ACTIVITY_HEAL)
                        pass
                    else :
                        #CvUtil.pyPrint( "Starting mission ..." )
                        #pGroup.pushMission( MissionTypes.MISSION_FORTIFY, 0, 0, 0, False, True, MissionAITypes.MISSIONAI_GUARD_CITY, pGroup.plot(), pGroup.getHeadUnit() )
                        pGroup.setActivityType(ActivityTypes.ACTIVITY_SLEEP)
                        headUnit.NotifyEntity( MissionTypes.MISSION_FORTIFY )
                        pass
                        
##                if( pGroup.getActivityType() == ActivityTypes.ACTIVITY_AWAKE ) :
##
##                    CvUtil.pyPrint( "Group with %s is awake"%(pGroup.getHeadUnit().getName()) )
##                    #pGroup.setActivityType(ActivityTypes.ACTIVITY_SLEEP)
##
##                else :
##                    CvUtil.pyPrint( "Group with %s had activity type %d"%(pGroup.getHeadUnit().getName(),pGroup.getActivityType()) )
##
##                if( pGroup.getLengthMissionQueue() == 0 ) :
##                    CvUtil.pyPrint( "Group with %s has no mission"%(pGroup.getHeadUnit().getName()) )
##
##                if( pGroup.getActivityType() == ActivityTypes.ACTIVITY_HOLD ) :
##                    CvUtil.pyPrint( "Testing can start mission ..." )
##                    if( pGroup.canStartMission( MissionTypes.MISSION_FORTIFY, 0, 0, pGroup.plot(), True ) ) :
##                        CvUtil.pyPrint( "Can start mission ..." )
##
##                    CvUtil.pyPrint( "Starting mission ..." )
##                    pGroup.pushMission( MissionTypes.MISSION_FORTIFY, 0, 0, 0, False, True, MissionAITypes.MISSIONAI_GUARD_CITY, pGroup.plot(), pGroup.getHeadUnit() )
##                    #pGroup.setActivityType(ActivityTypes.ACTIVITY_SLEEP)

##                if( pGroup.getLengthMissionQueue() > 0 ) :
##                    CvUtil.pyPrint( "Group with %s has a mission"%(pGroup.getHeadUnit().getName()) )

    def onKbdEvent( self, argsList ) :
        'keypress handler'
        eventType,key,mx,my,px,py = argsList

        if ( eventType == self.EventKeyDown ):
	    theKey=int(key)

	    if( theKey == int(InputTypes.KB_X) and self.customEM.bShift and self.customEM.bCtrl ) :
                # Get it?  Shift ... control ... to the AI
                if( game.getAIAutoPlay() > 0 ) :
                    if( self.bCanCancelAuto ) :
                        if( self.refortify ) :
                            self.doRefortify( game.getActivePlayer() )
                        self.setAIAutoPlay( 0 )
                        self.checkDeadPlayer()
                else :
                    self.toAIChooser()

            if( theKey == int(InputTypes.KB_M) and self.customEM.bShift and self.customEM.bCtrl ) :
                # Toggle auto moves
                if( self.LOG_DEBUG ) : CyInterface().addImmediateMessage("Moving your units...","")
                #self.playerID = gc.getActivePlayer().getID()
                self.setAIAutoPlay( 1 )

            if( theKey == int(InputTypes.KB_O) and self.customEM.bShift and self.customEM.bCtrl ) :
                self.doRefortify( game.getActivePlayer() )


    def onBeginGameTurn( self, argsList):
        'Called at the beginning of the end of each turn'
        iGameTurn = argsList[0]
        if( game.getAIAutoPlay() == 0 ) :
            CvTopCivs.CvTopCivs().turnChecker(iGameTurn)

    def onCityBuilt(self, argsList):
        'City Built'
        city = argsList[0]
        if (city.getOwner() == CyGame().getActivePlayer() and game.getAIAutoPlay() == 0 ):
                self.customEM.onCityBuilt(argsList)
        else :
                try :
                    CvUtil.pyPrint('City Built Event: %s' %(city.getName()))
                except :
                    CvUtil.pyPrint('City Built Event: Error processing city name' )
                

    def toAIChooser( self ) :
        'Chooser window for when user switches to AI auto play'

        popup = PyPopup.PyPopup(self.toAIChooserPopup,contextType = EventContextTypes.EVENTCONTEXT_ALL)
        popup.setHeaderString( localText.getText("TXT_KEY_AIAUTOPLAY_TURN_ON", ()) )
	popup.setBodyString( localText.getText("TXT_KEY_AIAUTOPLAY_TURNS", ()) )
        popup.addSeparator()
        popup.createPythonEditBox( '10', 'Number of turns to turn over to AI', 0)

        self.AutoTypes={
                        0 : localText.getText("TXT_KEY_AIAUTOPLAY_FULLY", ()),
                        1 : localText.getText("TXT_KEY_AIAUTOPLAY_NO", ()),
                        #2 : localText.getText("TXT_KEY_AIAUTOPLAY_UNIT", ()),
                        #3 : localText.getText("TXT_KEY_AIAUTOPLAY_DEBUG", ()),
                        }
        
        popup.createPythonPullDown( localText.getText("TXT_KEY_AIAUTOPLAY_AUTOMATION", ()), 2 )
        for i in range(0,len(self.AutoTypes)) :
            popup.addPullDownString( self.AutoTypes[i], i, 2 )

        popup.popup.setSelectedPulldownID( 0, 2 )
            
        #popup.createPythonCheckBoxes( 4, 3 )
        #popup.setPythonCheckBoxText( 0, 'Pause at turn end', 'Pauses automation at the end of the turn, so you can inspect things', 3 )
        #popup.setPythonCheckBoxText( 1, 'Pause every 10', 'Pauses automation every 10 turns', 3 )
        #popup.setPythonCheckBoxText( 2, 'Cancel on war declared', 'Cancel automation if your civ becomes involved in a war', 3 )
        #popup.setPythonCheckBoxText( 3, 'Wake-up on game end', 'If someone (your civ?) wins, automation cancelled', 3 )

        popup.addSeparator()
        popup.addButton("OK")
        popup.addButton(localText.getText("TXT_KEY_AIAUTOPLAY_CANCEL", ()))

        popup.launch(False, PopupStates.POPUPSTATE_IMMEDIATE)

    def AIChooserHandler( self, playerID, netUserData, popupReturn ) :
        'Handles AIChooser popup'
        if( popupReturn.getButtonClicked() == 1 ):  # if you pressed cancel
            return
        
        numTurns = 0
        self.playerID = playerID
        if( popupReturn.getEditBoxString(0) != '' ) :
            numTurns = int( popupReturn.getEditBoxString(0) )

        autoIdx = popupReturn.getSelectedPullDownValue( 2 )
        
        if( autoIdx == 0 ) :
            if( numTurns > 0 ) :
                if( self.LOG_DEBUG ) : CyInterface().addImmediateMessage("Fully automate","")
                self.abdicate( numTurns = numTurns, voluntary = 1 )
        elif( autoIdx == 1 ) :
            if( self.LOG_DEBUG ) : CyInterface().addImmediateMessage("Clearing all automation","")
            #self.clearAllAutomation( )
        elif( autoIdx == 2 and numTurns > 0 ) :
            if( self.LOG_DEBUG ) : CyInterface().addImmediateMessage("Auto Move","")
            self.setAutoMoves( numTurns )
        elif( autoIdx == 3 and numTurns > 0 ) :
            if( self.LOG_DEBUG ) : CyInterface().addImmediateMessage("Debug Mode","")
            self.setDebugMode( numTurns )

        # How to read out checkboxes?  popupReturn doesn't seem to have a function
        #bitField = popupReturn.getCheckBoxBitfield( 3 )
        #self.bPause =
        #CyInterface().addImmediateMessage("bitfieldsize: %d"%(len(bitField)),"")

    def abdicate( self, numTurns = -1, voluntary = 0 ) :
        'Turn over control to the AI'
        if( numTurns > 0 ) :
            self.TurnsToAuto = numTurns

        if( self.TurnsToAuto < 1 ) :
            return

        if( voluntary and self.SHOW_NEW_LEADER_POPUP ) :
            popup = PyPopup.PyPopup(self.abdicatePopup,contextType = EventContextTypes.EVENTCONTEXT_ALL)
            popup.setHeaderString( localText.getText("TXT_KEY_AIAUTOPLAY_NEW_LEADER", ()) )
            if( voluntary ) :
                bodStr = localText.getText("TXT_KEY_AIAUTOPLAY_ABDICATE", ())
            else :
                bodStr = localText.getText("TXT_KEY_AIAUTOPLAY_USURPATOR", ())
            bodStr = bodStr +  localText.getText("TXT_KEY_AIAUTOPLAY_GOOD_NEWS", ()) %(self.TurnsToAuto)
            popup.setBodyString( bodStr )
            popup.launch()
        else :
            if( voluntary ) : self.bCanCancelAuto = True
            self.setAIAutoPlay( self.TurnsToAuto )
        
    def abdicateHandler( self, playerID, netUserData, popupReturn ) :
        'Handle abdicate popup'
        self.bCanCancelAuto = True
        self.setAIAutoPlay( self.TurnsToAuto )

    def setAIAutoPlay( self, iNumTurns ) :
        game.setAIAutoPlay( iNumTurns )

   

## --------------- All functions below this line are not currently used, may not perform as expected -------------------

    def setAutoMoves( self, numTurns ) :
        if( numTurns > 0 ) :
            gc.getPlayer(self.playerID).setAutoMoves( 1 )

    def clearAllAutomation( self ) :
        game.setAIAutoPlay( 0 )
        gc.getPlayer(self.playerID).setAutoMoves( False )
        if( game.isDebugMode( ) ) :
            game.toggleDebugMode( )

    def setDebugMode ( self, numTurns ) :
        if( not game.isDebugMode( ) ) :
            game.toggleDebugMode( )
        self.abdicate( numTurns, 1 )

    def onChangeWar( self, argsList ) :
        bIsWar = argsList[0]
	iPlayer = argsList[1]
	iRivalTeam = argsList[2]
        if( game.getAIAutoPlay( ) > 0 ) :
            if( self.bWakeOnWar and bIsWar ) :
                if( iPlayer == self.playerID or iRivalTeam == gc.getPlayer(playerID).getTeam() ) :
                    CyInterface().addImmediateMessage("Wake on war","")

    def onVictory( self, argsList ) :
        iTeam, iVictory = argsList
        if( game.getAIAutoPlay( ) > 0 ) :
            if( self.bWakeOnVic ) :
                CyInterface().addImmediateMessage("Wake on victory","")
