# AutoUtils.py


from CvPythonExtensions import *
import CvUtil
import PyHelpers
import Popup as PyPopup

# globals
gc = CyGlobalContext()
PyPlayer = PyHelpers.PyPlayer
PyInfo = PyHelpers.PyInfo
game = CyGame()

LOG_DEBUG = True
refortify = True

fortifyList = list()

########################## Event Handling ##########################################################

def registerEvents( customEM, config ) :

    global LOG_DEBUG, refortify, fortifyList
    
    LOG_DEBUG = config.getboolean("AIAutoPlay", "DebugMode", LOG_DEBUG)
    refortify = config.getboolean("AIAutoPlay", "Refortify", refortify)
    fortifyList = list()

    customEM.addEventHandler( 'EndPlayerTurn', onEndPlayerTurn )

def onEndPlayerTurn( argsList ) :

    global fortifyList

    iGameTurn, iPlayer = argsList

    if( refortify and iPlayer == game.getActivePlayer() and game.getAIAutoPlay() == 1 ) :
        pyPlayer = PyPlayer( iPlayer )

        for unit in pyPlayer.getUnitList() :
            if( unit.fortifyModifier() > 0 ) :
                pGroup = unit.getGroup()
                if pGroup.getActivityType() != ActivityTypes.ACTIVITY_SLEEP:
                    pGroup.setActivityType(ActivityTypes.ACTIVITY_SLEEP)

##      This code (with code in setAIAutoPlay) refortifies only those units who were fortified on last human turn
##        if( LOG_DEBUG ) : print 'Refortifying units for player %d'%(iPlayer)
##        
##        for fortifyElement in fortifyList :
##            for unit in pyPlayer.getUnitList() :
##                if( fortifyElement[0] == unit.getID() ) :
##                    # Found unit that was fortified, check if moved
##                    if( fortifyElement[1] == unit.getX() and fortifyElement[2] == unit.getY() ) :
##                        # Same place, so return to fortify
##                        pGroup = unit.getGroup()
##			if pGroup.getActivityType() != ActivityTypes.ACTIVITY_SLEEP:
##			    pGroup.setActivityType(ActivityTypes.ACTIVITY_SLEEP)

        fortifyList = list()
    

def setAIAutoPlay( numTurns, doFortify = False ) :

    global fortifyList

##    if( LOG_DEBUG ) : print 'Doing automation'
##      Builds list of units fortified on last human turn
##    if( doFortify ) :
##        if( len(fortifyList) > 0 ) :
##            fortifyList = list()
##        iPlayer = game.getActivePlayer()
##        pyPlayer = PyPlayer( iPlayer )
##        
##        for unit in pyPlayer.getUnitList() :
##            if( unit.getFortifyTurns() > 0 ) :
##                fortifyList.append( [unit.getID(), unit.getX(), unit.getY()] )
##
##        if( LOG_DEBUG ) : print 'Player %d had %d units fortified'%(iPlayer, len(fortifyList))
    
    game.setAIAutoPlay( numTurns )
